Subject: Re: de-alphabetizing the documentation

From: Eric Sunshine <[email-masked]>
Date: Fri, 6 Jul 2018 17:32:39 -0400

On Fri, Jul 06, 2018 at 02:16:00PM -0700, Jonathan Nieder wrote:
> Frederick Eaton wrote:
> > I wonder if someone familiar with Git could list the commands in an
> > order which makes more sense for learning, for example in the order in
> > which they were invented by Git developers,
> 
> Alas, there are plenty of "Main porcelain commands", and I think that
> is where your question comes from.  It would be nicer to list just five
> to start, say.

"git help" makes some attempt at narrowing the list of porcelain
commands likely to be used on an everyday basis (and it categorizes
the list by general activity). Of the 21 commands listed, I use 14-16
in pretty much every development session, so "git help" might be a
good starting place for someone trying to figure out which commands to
study, or for someone wishing to help focus the documentation a bit
more for beginners.

--- >8 ---
$ git help
usage: git ...

These are common Git commands used in various situations:

start a working area (see also: git help tutorial)
   clone      Clone a repository into a new directory
   init       Create an empty Git repository or reinitialize an existing one

work on the current change (see also: git help everyday)
   add        Add file contents to the index
   mv         Move or rename a file, a directory, or a symlink
   reset      Reset current HEAD to the specified state
   rm         Remove files from the working tree and from the index

examine the history and state (see also: git help revisions)
   bisect     Use binary search to find the commit that introduced a bug
   grep       Print lines matching a pattern
   log        Show commit logs
   show       Show various types of objects
   status     Show the working tree status

grow, mark and tweak your common history
   branch     List, create, or delete branches
   checkout   Switch branches or restore working tree files
   commit     Record changes to the repository
   diff       Show changes between commits, commit and working tree, etc
   merge      Join two or more development histories together
   rebase     Reapply commits on top of another base tip
   tag        Create, list, delete or verify a tag object signed with GPG

collaborate (see also: git help workflows)
   fetch      Download objects and refs from another repository
   pull       Fetch from and integrate with another repository or a local branch
   push       Update remote refs along with associated objects

'git help -a' and 'git help -g' list available subcommands and some
concept guides. See 'git help <command>' or 'git help <concept>'
to read about a specific subcommand or concept.
--- >8 ---